/[gentoo-x86]/eclass/kde4-base.eclass
Gentoo

Diff of /eclass/kde4-base.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.6 Revision 1.119
1# Copyright 2007-2008 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-base.eclass,v 1.6 2008/03/26 20:39:05 zlin Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-base.eclass,v 1.119 2012/06/22 09:19:46 kensington Exp $
4 4
5# @ECLASS: kde4-base.eclass 5# @ECLASS: kde4-base.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# kde@gentoo.org 7# kde@gentoo.org
8# @BLURB: This eclass provides functions for kde 4.0 ebuilds 8# @BLURB: This eclass provides functions for kde 4.X ebuilds
9# @DESCRIPTION: 9# @DESCRIPTION:
10# The kde4-base.eclass provides support for building KDE4 monolithic ebuilds 10# The kde4-base.eclass provides support for building KDE4 based ebuilds
11# and KDE4 applications. 11# and KDE4 applications.
12# 12#
13# NOTE: This eclass uses the SLOT dependencies from EAPI="1" or compatible, 13# NOTE: KDE 4 ebuilds currently support EAPI "3". This will be reviewed
14# hence you must define EAPI="1" in the ebuild, before inheriting any eclasses. 14# over time as new EAPI versions are approved.
15 15
16inherit base eutils multilib cmake-utils kde4-functions 16# @ECLASS-VARIABLE: KDE_SELINUX_MODULE
17# @DESCRIPTION:
18# If set to "none", do nothing.
19# For any other value, add selinux to IUSE, and depending on that useflag
20# add a dependency on sec-policy/selinux-${KDE_SELINUX_MODULE} to (R)DEPEND
21: ${KDE_SELINUX_MODULE:=none}
17 22
23# @ECLASS-VARIABLE: VIRTUALDBUS_TEST
24# @DESCRIPTION:
25# If defined, launch and use a private dbus session during src_test.
26
27# @ECLASS-VARIABLE: VIRTUALX_REQUIRED
28# @DESCRIPTION:
29# For proper description see virtualx.eclass manpage.
30# Here we redefine default value to be manual, if your package needs virtualx
31# for tests you should proceed with setting VIRTUALX_REQUIRED=test.
32: ${VIRTUALX_REQUIRED:=manual}
33
34inherit kde4-functions toolchain-funcs fdo-mime flag-o-matic gnome2-utils base virtualx versionator eutils multilib
35
36if [[ ${BUILD_TYPE} = live ]]; then
37 case ${KDE_SCM} in
38 svn) inherit subversion ;;
39 git) inherit git-2 ;;
40 esac
41fi
42
43# @ECLASS-VARIABLE: CMAKE_REQUIRED
44# @DESCRIPTION:
45# Specify if cmake buildsystem is being used. Possible values are 'always' and 'never'.
46# Please note that if it's set to 'never' you need to explicitly override following phases:
47# src_configure, src_compile, src_test and src_install.
48# Defaults to 'always'.
49: ${CMAKE_REQUIRED:=always}
50if [[ ${CMAKE_REQUIRED} = always ]]; then
51 buildsystem_eclass="cmake-utils"
52 export_fns="src_configure src_compile src_test src_install"
53fi
54
55# @ECLASS-VARIABLE: KDE_MINIMAL
56# @DESCRIPTION:
57# This variable is used when KDE_REQUIRED is set, to specify required KDE minimal
58# version for apps to work. Currently defaults to 4.4
59# One may override this variable to raise version requirements.
60# Note that it is fixed to ${PV} for kde-base packages.
61KDE_MINIMAL="${KDE_MINIMAL:-4.4}"
62
63# Set slot for KDEBASE known packages
64case ${KDEBASE} in
65 kde-base)
66 SLOT=4
67 KDE_MINIMAL="${PV}"
68 ;;
69 koffice)
70 SLOT="2"
71 ;;
72 kdevelop)
73 if [[ ${BUILD_TYPE} = live ]]; then
74 # @ECLASS-VARIABLE: KDEVELOP_VERSION
75 # @DESCRIPTION:
76 # Specifies KDevelop version. Default is 4.0.0 for tagged packages and 9999 for live packages.
77 # Applies to KDEBASE=kdevelop only.
78 KDEVELOP_VERSION="${KDEVELOP_VERSION:-9999}"
79 # @ECLASS-VARIABLE: KDEVPLATFORM_VERSION
80 # @DESCRIPTION:
81 # Specifies KDevplatform version. Default is 1.0.0 for tagged packages and 9999 for live packages.
82 # Applies to KDEBASE=kdevelop only.
83 KDEVPLATFORM_VERSION="${KDEVPLATFORM_VERSION:-9999}"
84 else
85 case ${PN} in
86 kdevelop|quanta)
87 KDEVELOP_VERSION=${PV}
88 KDEVPLATFORM_VERSION="$(($(get_major_version)-3)).$(get_after_major_version)"
89 ;;
90 kdevplatform|kdevelop-php*)
91 KDEVELOP_VERSION="$(($(get_major_version)+3)).$(get_after_major_version)"
92 KDEVPLATFORM_VERSION=${PV}
93 ;;
94 *)
95 KDEVELOP_VERSION="${KDEVELOP_VERSION:-4.0.0}"
96 KDEVPLATFORM_VERSION="${KDEVPLATFORM_VERSION:-1.0.0}"
97 esac
98 fi
99 SLOT="4"
100 ;;
101esac
102
103inherit ${buildsystem_eclass}
104
18EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_test src_install pkg_postinst pkg_postrm 105EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare ${export_fns} pkg_preinst pkg_postinst pkg_postrm
19 106
20COMMONDEPEND="|| ( ( 107unset buildsystem_eclass
21 x11-libs/qt-core:4 108unset export_fns
22 x11-libs/qt-gui:4 109
23 x11-libs/qt-qt3support:4 110# @ECLASS-VARIABLE: DECLARATIVE_REQUIRED
24 x11-libs/qt-svg:4 111# @DESCRIPTION:
25 x11-libs/qt-test:4 ) 112# Is qt-declarative required? Possible values are 'always', 'optional' and 'never'.
26 >=x11-libs/qt-4.3.3:4 )" 113# This variable must be set before inheriting any eclasses. Defaults to 'never'.
114DECLARATIVE_REQUIRED="${DECLARATIVE_REQUIRED:-never}"
115
116# @ECLASS-VARIABLE: QTHELP_REQUIRED
117# @DESCRIPTION:
118# Is qt-assistant required? Possible values are 'always', 'optional' and 'never'.
119# This variable must be set before inheriting any eclasses. Defaults to 'never'.
120QTHELP_REQUIRED="${QTHELP_REQUIRED:-never}"
27 121
28# @ECLASS-VARIABLE: OPENGL_REQUIRED 122# @ECLASS-VARIABLE: OPENGL_REQUIRED
29# @DESCRIPTION: 123# @DESCRIPTION:
30# Is qt-opengl required? Possible values are 'always', 'optional' and 'never'. 124# Is qt-opengl required? Possible values are 'always', 'optional' and 'never'.
31# This variable must be set before inheriting any eclasses. Defaults to 'never'. 125# This variable must be set before inheriting any eclasses. Defaults to 'never'.
32OPENGL_REQUIRED="${OPENGL_REQUIRED:-never}" 126OPENGL_REQUIRED="${OPENGL_REQUIRED:-never}"
33 127
34OPENGLDEPEND="|| ( x11-libs/qt-opengl:4 128# @ECLASS-VARIABLE: MULTIMEDIA_REQUIRED
35 >=x11-libs/qt-4.3.3:4 )" 129# @DESCRIPTION:
36case "${OPENGL_REQUIRED}" in 130# Is qt-multimedia required? Possible values are 'always', 'optional' and 'never'.
37 always) 131# This variable must be set before inheriting any eclasses. Defaults to 'never'.
38 COMMONDEPEND="${COMMONDEPEND} 132MULTIMEDIA_REQUIRED="${MULTIMEDIA_REQUIRED:-never}"
39 ${OPENGLDEPEND}"
40 ;;
41 optional)
42 IUSE="${IUSE} opengl"
43 COMMONDEPEND="${COMMONDEPEND}
44 opengl? ( ${OPENGLDEPEND} )"
45 ;;
46 *)
47 OPENGL_REQUIRED="never"
48 ;;
49esac
50
51DEPEND="${DEPEND} ${COMMONDEPEND}
52 >=dev-util/cmake-2.4.7-r1
53 dev-util/pkgconfig
54 x11-libs/libXt
55 x11-proto/xf86vidmodeproto"
56RDEPEND="${RDEPEND} ${COMMONDEPEND}"
57 133
58# @ECLASS-VARIABLE: CPPUNIT_REQUIRED 134# @ECLASS-VARIABLE: CPPUNIT_REQUIRED
59# @DESCRIPTION: 135# @DESCRIPTION:
60# Is cppunit required for tests? Possible values are 'always', 'optional' and 'never'. 136# Is cppunit required for tests? Possible values are 'always', 'optional' and 'never'.
61# This variable must be set before inheriting any eclasses. Defaults to 'never'. 137# This variable must be set before inheriting any eclasses. Defaults to 'never'.
62CPPUNIT_REQUIRED="${CPPUNIT_REQUIRED:-never}" 138CPPUNIT_REQUIRED="${CPPUNIT_REQUIRED:-never}"
63 139
64case "${CPPUNIT_REQUIRED}" in 140# @ECLASS-VARIABLE: KDE_REQUIRED
141# @DESCRIPTION:
142# Is kde required? Possible values are 'always', 'optional' and 'never'.
143# This variable must be set before inheriting any eclasses. Defaults to 'always'
144# If set to 'always' or 'optional', KDE_MINIMAL may be overriden as well.
145# Note that for kde-base packages this variable is fixed to 'always'.
146KDE_REQUIRED="${KDE_REQUIRED:-always}"
147
148# @ECLASS-VARIABLE: KDE_HANDBOOK
149# @DESCRIPTION:
150# Set to enable handbook in application. Possible values are 'always', 'optional'
151# (handbook USE flag) and 'never'.
152# This variable must be set before inheriting any eclasses. Defaults to 'never'.
153# It adds default handbook dirs for kde-base packages to KMEXTRA and in any case it
154# ensures buildtime and runtime dependencies.
155KDE_HANDBOOK="${KDE_HANDBOOK:-never}"
156
157# @ECLASS-VARIABLE: KDE_LINGUAS_LIVE_OVERRIDE
158# @DESCRIPTION:
159# Set this varible if you want your live package to manage its
160# translations. (Mostly all kde ebuilds does not ship documentation
161# and translations in live ebuilds)
162if [[ ${BUILD_TYPE} == live && -z ${KDE_LINGUAS_LIVE_OVERRIDE} ]]; then
163 # Kdebase actualy provides the handbooks even for live stuff
164 [[ ${KDEBASE} == kde-base ]] || KDE_HANDBOOK=never
165 KDE_LINGUAS=""
166fi
167
168# Setup packages inheriting this eclass
169case ${KDEBASE} in
170 kde-base)
171 HOMEPAGE="http://www.kde.org/"
172 LICENSE="GPL-2"
173 if [[ ${BUILD_TYPE} = live && -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
174 # Disable tests for live ebuilds by default
175 RESTRICT+=" test"
176 fi
177
178 # Only add the kdeprefix USE flag for older versions, to help
179 # non-portage package managers handle the upgrade
180 if [[ ${PV} < 4.6.4 && ( ( ${KMNAME} != kdepim && ${PN} != kdepim-runtime ) || ${PV} < 4.6 ) ]]; then
181 IUSE+=" kdeprefix"
182 fi
183
184 # This code is to prevent portage from searching GENTOO_MIRRORS for
185 # packages that will never be mirrored. (As they only will ever be in
186 # the overlay).
187 case ${PV} in
188 *9999* | 4.?.[6-9]?)
189 RESTRICT+=" mirror"
190 ;;
191 esac
192 ;;
193 koffice)
194 HOMEPAGE="http://www.koffice.org/"
195 LICENSE="GPL-2"
196 ;;
197 kdevelop)
198 HOMEPAGE="http://www.kdevelop.org/"
199 LICENSE="GPL-2"
200 ;;
201esac
202
203# @ECLASS-VARIABLE: QT_MINIMAL
204# @DESCRIPTION:
205# Determine version of qt we enforce as minimal for the package.
206if version_is_at_least 4.8.50 "${KDE_MINIMAL}"; then
207 # Upstream has added an *undeclared* dependency on Qt 4.8...
208 QT_MINIMAL="${QT_MINIMAL:-4.8.0}"
209elif version_is_at_least 4.7.80 "${KDE_MINIMAL}"; then
210 QT_MINIMAL="${QT_MINIMAL:-4.7.4}"
211else
212 QT_MINIMAL="${QT_MINIMAL:-4.7.0}"
213fi
214
215# Declarative dependencies
216qtdeclarativedepend="
217 >=x11-libs/qt-declarative-${QT_MINIMAL}:4
218"
219case ${DECLARATIVE_REQUIRED} in
65 always) 220 always)
66 DEPEND="${DEPEND} dev-util/cppunit" 221 COMMONDEPEND+=" ${qtdeclarativedepend}"
67 ;; 222 ;;
68 optional) 223 optional)
69 IUSE="${IUSE} test" 224 IUSE+=" declarative"
70 DEPEND="${DEPEND} 225 COMMONDEPEND+=" declarative? ( ${qtdeclarativedepend} )"
71 test? ( dev-util/cppunit )"
72 ;; 226 ;;
227 *) ;;
228esac
229unset qtdeclarativedepend
230
231# QtHelp dependencies
232qthelpdepend="
233 >=x11-libs/qt-assistant-${QT_MINIMAL}:4
234"
235case ${QTHELP_REQUIRED} in
236 always)
237 COMMONDEPEND+=" ${qthelpdepend}"
238 ;;
239 optional)
240 IUSE+=" qthelp"
241 COMMONDEPEND+=" qthelp? ( ${qthelpdepend} )"
242 ;;
243esac
244unset qthelpdepend
245
246# OpenGL dependencies
247qtopengldepend="
248 >=x11-libs/qt-opengl-${QT_MINIMAL}:4
249"
250case ${OPENGL_REQUIRED} in
251 always)
252 COMMONDEPEND+=" ${qtopengldepend}"
253 ;;
254 optional)
255 IUSE+=" opengl"
256 COMMONDEPEND+=" opengl? ( ${qtopengldepend} )"
257 ;;
258 *) ;;
259esac
260unset qtopengldepend
261
262# MultiMedia dependencies
263qtmultimediadepend="
264 >=x11-libs/qt-multimedia-${QT_MINIMAL}:4
265"
266case ${MULTIMEDIA_REQUIRED} in
267 always)
268 COMMONDEPEND+=" ${qtmultimediadepend}"
269 ;;
270 optional)
271 IUSE+=" multimedia"
272 COMMONDEPEND+=" multimedia? ( ${qtmultimediadepend} )"
273 ;;
274 *) ;;
275esac
276unset qtmultimediadepend
277
278# CppUnit dependencies
279cppuintdepend="
280 dev-util/cppunit
281"
282case ${CPPUNIT_REQUIRED} in
283 always)
284 DEPEND+=" ${cppuintdepend}"
285 ;;
286 optional)
287 IUSE+=" test"
288 DEPEND+=" test? ( ${cppuintdepend} )"
289 ;;
290 *) ;;
291esac
292unset cppuintdepend
293
294# KDE dependencies
295# Qt accessibility classes are needed in various places, bug 325461
296kdecommondepend="
297 dev-lang/perl
298 >=x11-libs/qt-core-${QT_MINIMAL}:4[qt3support,ssl]
299 >=x11-libs/qt-dbus-${QT_MINIMAL}:4
300 >=x11-libs/qt-gui-${QT_MINIMAL}:4[accessibility,dbus]
301 >=x11-libs/qt-qt3support-${QT_MINIMAL}:4[accessibility]
302 >=x11-libs/qt-script-${QT_MINIMAL}:4
303 >=x11-libs/qt-sql-${QT_MINIMAL}:4[qt3support]
304 >=x11-libs/qt-svg-${QT_MINIMAL}:4
305 >=x11-libs/qt-test-${QT_MINIMAL}:4
306 >=x11-libs/qt-webkit-${QT_MINIMAL}:4
307 !aqua? (
308 x11-libs/libXext
309 x11-libs/libXt
310 x11-libs/libXxf86vm
311 x11-libs/libXcomposite
312 x11-libs/libxkbfile
313 )
314"
315
316if [[ ${PN} != kdelibs ]]; then
317 kdecommondepend+=" $(add_kdebase_dep kdelibs)"
318 if [[ ${KDEBASE} = kdevelop ]]; then
319 if [[ ${PN} != kdevplatform ]]; then
320 # @ECLASS-VARIABLE: KDEVPLATFORM_REQUIRED
321 # @DESCRIPTION:
322 # Specifies whether kdevplatform is required. Possible values are 'always' (default) and 'never'.
323 # Applies to KDEBASE=kdevelop only.
324 KDEVPLATFORM_REQUIRED="${KDEVPLATFORM_REQUIRED:-always}"
325 case ${KDEVPLATFORM_REQUIRED} in
326 always)
327 kdecommondepend+="
328 >=dev-util/kdevplatform-${KDEVPLATFORM_VERSION}
329 "
330 ;;
331 *) ;;
332 esac
333 fi
334 fi
335fi
336
337kdedepend="
338 dev-util/automoc
339 virtual/pkgconfig
340 !aqua? (
341 >=x11-libs/libXtst-1.1.0
342 x11-proto/xf86vidmodeproto
343 )
344"
345
346kderdepend=""
347
348# all packages needs oxygen icons for basic iconset
349if [[ ${PN} != oxygen-icons ]]; then
350 kderdepend+=" $(add_kdebase_dep oxygen-icons)"
351fi
352
353# add a dependency over kde-l10n if EAPI4 or better is around
354if [[ ${KDEBASE} != "kde-base" && -n ${KDE_LINGUAS} && ${EAPI:-0} != 3 ]]; then
355 for _lingua in ${KDE_LINGUAS}; do
356 # if our package has lignuas, pull in kde-l10n with selected lingua enabled,
357 # but only for selected ones.
358 # this can't be done on one line because if user doesn't use any localisation
359 # then he is probably not interested in kde-l10n at all.
360 kderdepend+="
361 linguas_${_lingua}? ( $(add_kdebase_dep kde-l10n "linguas_${_lingua}(+)") )
362 "
363 done
364 unset _lingua
365fi
366
367kdehandbookdepend="
368 app-text/docbook-xml-dtd:4.2
369 app-text/docbook-xsl-stylesheets
370"
371kdehandbookrdepend="
372 $(add_kdebase_dep kdelibs 'handbook')
373"
374case ${KDE_HANDBOOK} in
375 always)
376 kdedepend+=" ${kdehandbookdepend}"
377 [[ ${PN} != kdelibs ]] && kderdepend+=" ${kdehandbookrdepend}"
378 ;;
379 optional)
380 IUSE+=" +handbook"
381 kdedepend+=" handbook? ( ${kdehandbookdepend} )"
382 [[ ${PN} != kdelibs ]] && kderdepend+=" handbook? ( ${kdehandbookrdepend} )"
383 ;;
384 *) ;;
385esac
386unset kdehandbookdepend kdehandbookrdepend
387
388case ${KDE_SELINUX_MODULE} in
389 none) ;;
73 *) 390 *)
74 CPPUNIT_REQUIRED="never" 391 IUSE+=" selinux"
392 kdecommondepend+=" selinux? ( sec-policy/selinux-${KDE_SELINUX_MODULE} )"
75 ;; 393 ;;
76esac 394esac
77 395
78# @ECLASS-VARIABLE: NEED_KDE 396case ${KDE_REQUIRED} in
79# @DESCRIPTION: 397 always)
80# This variable sets the version of KDE4 which will be used by the eclass. 398 IUSE+=" aqua"
81# This variable must be set by the ebuild, for all categories except for "kde-base". 399 [[ -n ${kdecommondepend} ]] && COMMONDEPEND+=" ${kdecommondepend}"
82# For kde-base packages, if it is not set by the ebuild, 400 [[ -n ${kdedepend} ]] && DEPEND+=" ${kdedepend}"
83# it's assumed that the required KDE4 version is the latest, non-live, available. 401 [[ -n ${kderdepend} ]] && RDEPEND+=" ${kderdepend}"
84#
85# @CODE
86# Acceptable values are:
87# - latest - Use latest version in the portage tree
88# Default for kde-base ebuilds. Banned for ebuilds not part of kde or koffice.
89# - svn - Use svn release (live ebuilds)
90# - :SLOT - Use any version in the SLOT specified in the NEED_KDE value.
91# - VERSION_NUMBER - Use the minimum KDE4 version specified in the NEED_KDE value.
92# - VERSION_NUMBER:SLOT - Use the minimum KDE4 version and the SLOT specified in the NEED_KDE value.
93# - none - Let the ebuild handle SLOT, kde dependencies, KDEDIR, ...
94# @CODE
95#
96# Note: There is no default NEED_KDE for ebuilds not in kde-base or part of
97# koffice, so you must set it explicitly in the ebuild, in all other cases.
98if [[ -z ${NEED_KDE} ]]; then
99 if [[ -n ${KDEBASE} ]]; then
100 NEED_KDE="latest"
101 else
102 die "kde4-base.eclass inherited but NEED_KDE not defined - broken ebuild"
103 fi
104fi
105export NEED_KDE
106
107case ${NEED_KDE} in
108 latest)
109 # Should only be used by 'kde-base'-ebuilds
110 if [[ "${KDEBASE}" == "kde-base" ]]; then
111 case ${PV} in
112 3.9*) _kdedir="3.9" ;;
113 4*) _kdedir="4.0" ;;
114 *) die "NEED_KDE=latest not supported for PV=${PV}" ;;
115 esac
116 _operator=">="
117 _pv="-${PV}:kde-4"
118 else
119 _kdedir="4.0"
120 _pv=":kde-4"
121 fi
122 ;; 402 ;;
123 svn|9999*|:kde-svn) 403 optional)
124 _kdedir="svn" 404 IUSE+=" aqua kde"
125 _pv=":kde-svn" 405 [[ -n ${kdecommondepend} ]] && COMMONDEPEND+=" kde? ( ${kdecommondepend} )"
126 export NEED_KDE="svn" 406 [[ -n ${kdedepend} ]] && DEPEND+=" kde? ( ${kdedepend} )"
407 [[ -n ${kderdepend} ]] && RDEPEND+=" kde? ( ${kderdepend} )"
127 ;; 408 ;;
128 *:kde-svn) 409 *) ;;
129 _kdedir="svn"
130 _operator=">="
131 _pv="-${NEED_KDE}"
132 export NEED_KDE="svn"
133 ;;
134 # The ebuild handles dependencies, KDEDIR, SLOT.
135 none)
136 :
137 ;;
138 # NEED_KDE=":${SLOT}"
139 :kde-4)
140 _kdedir="4.0"
141 _pv="${NEED_KDE}"
142 ;;
143 # NEED_KDE="${PV}:${SLOT}"
144 *:kde-4)
145 _kdedir="4.0"
146 _operator=">="
147 _pv="-${NEED_KDE}"
148 ;;
149 3.9*)
150 _kdedir="3.9"
151 _operator=">="
152 _pv="-${NEED_KDE}:kde-4"
153 ;;
154 4*)
155 _kdedir="4.0"
156 _operator=">="
157 _pv="-${NEED_KDE}:kde-4"
158 ;;
159 *) die "NEED_KDE=${NEED_KDE} currently not supported."
160 ;;
161esac 410esac
162 411
163if [[ ${NEED_KDE} != none ]]; then 412unset kdecommondepend kdedepend kderdepend
164 KDEDIR="/usr/kde/${_kdedir}"
165 KDEDIRS="/usr:/usr/local:${KDEDIR}"
166 413
167 if [[ -n ${KDEBASE} ]]; then 414debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: COMMONDEPEND is ${COMMONDEPEND}"
168 if [[ ${NEED_KDE} = svn ]]; then 415debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: DEPEND (only) is ${DEPEND}"
169 SLOT="kde-svn" 416debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: RDEPEND (only) is ${RDEPEND}"
170 else
171 SLOT="kde-4"
172 fi
173 fi
174 417
175 # We only need to add the dependencies if ${PN} is not "kdelibs" or "kdepimlibs" 418# Accumulate dependencies set by this eclass
176 if [[ ${PN} != "kdelibs" ]]; then
177 DEPEND="${DEPEND} 419DEPEND+=" ${COMMONDEPEND}"
178 ${_operator}kde-base/kdelibs${_pv}"
179 RDEPEND="${RDEPEND} 420RDEPEND+=" ${COMMONDEPEND}"
180 ${_operator}kde-base/kdelibs${_pv}" 421unset COMMONDEPEND
181 if [[ ${PN} != "kdepimlibs" ]]; then
182 DEPEND="${DEPEND}
183 ${_operator}kde-base/kdepimlibs${_pv}"
184 RDEPEND="${RDEPEND}
185 ${_operator}kde-base/kdepimlibs${_pv}"
186 fi
187 fi
188
189 unset _operator _pv _kdedir
190fi
191 422
192# Fetch section - If the ebuild's category is not 'kde-base' and if it is not a 423# Fetch section - If the ebuild's category is not 'kde-base' and if it is not a
193# koffice ebuild, the URI should be set in the ebuild itself 424# koffice ebuild, the URI should be set in the ebuild itself
194if [[ -n ${KDEBASE} ]]; then 425_calculate_src_uri() {
426 debug-print-function ${FUNCNAME} "$@"
427
428 local _kmname _kmname_pv
429
430 # we calculate URI only for known KDEBASE modules
431 [[ -n ${KDEBASE} ]] || return
432
433 # calculate tarball module name
195 if [[ -n ${KMNAME} ]]; then 434 if [[ -n ${KMNAME} ]]; then
435 # fixup kdebase-apps name
436 case ${KMNAME} in
437 kdebase-apps)
438 _kmname="kdebase" ;;
439 *)
196 _kmname=${KMNAME} 440 _kmname="${KMNAME}" ;;
441 esac
197 else 442 else
198 _kmname=${PN} 443 _kmname=${PN}
199 fi 444 fi
200 _kmname_pv="${_kmname}-${PV}" 445 _kmname_pv="${_kmname}-${PV}"
201 if [[ ${NEED_KDE} != "svn" ]]; then
202 case ${KDEBASE} in 446 case ${KDEBASE} in
203 kde-base) 447 kde-base)
204 case ${PV} in 448 case ${PV} in
449 4.4.11.1)
450 # KDEPIM 4.4, special case
451 # TODO: Remove this part when KDEPIM 4.4 gets out of the tree
452 SRC_URI="mirror://kde/stable/kdepim-${PV}/src/${_kmname_pv}.tar.bz2" ;;
453 4.[4567].8[05] | 4.[4567].9[0235678])
454 # Unstable KDE SC releases
455 SRC_URI="mirror://kde/unstable/${PV}/src/${_kmname_pv}.tar.bz2" ;;
456 4.8.[12345])
457 # Stable KDE SC releases with .xz support
458 SRC_URI="mirror://kde/stable/${PV}/src/${_kmname_pv}.tar.xz" ;;
459 4.[89].8[05] | 4.[89].9[0235678])
460 # Unstable KDE SC releases
461 SRC_URI="mirror://kde/unstable/${PV}/src/${_kmname_pv}.tar.xz" ;;
462 *)
463 # Stable KDE SC releases
205 *) SRC_URI="mirror://kde/stable/${PV}/src/${_kmname_pv}.tar.bz2";; 464 SRC_URI="mirror://kde/stable/${PV}/src/${_kmname_pv}.tar.bz2" ;;
206 esac 465 esac
207 ;; 466 ;;
208 koffice) 467 koffice)
468 case ${PV} in
469 2.[1234].[6-9]*) SRC_URI="mirror://kde/unstable/${_kmname_pv}/${_kmname_pv}.tar.bz2" ;;
209 SRC_URI="mirror://kde/unstable/${_kmname_pv}/src/${_kmname_pv}.tar.bz2" 470 *) SRC_URI="mirror://kde/stable/${_kmname_pv}/${_kmname_pv}.tar.bz2" ;;
471 esac
210 ;; 472 ;;
473 kdevelop|kdevelop-php*|kdevplatform)
474 case ${KDEVELOP_VERSION} in
475 4.[12].[6-9]*) SRC_URI="mirror://kde/unstable/kdevelop/${KDEVELOP_VERSION}/src/${P}.tar.bz2" ;;
476 *) SRC_URI="mirror://kde/stable/kdevelop/${KDEVELOP_VERSION}/src/${P}.tar.bz2" ;;
477 esac
478 ;;
479 esac
480}
481
482_calculate_live_repo() {
483 debug-print-function ${FUNCNAME} "$@"
484
485 SRC_URI=""
486 case ${KDE_SCM} in
487 svn)
488 # Determine branch URL based on live type
489 local branch_prefix
490 case ${PV} in
491 9999*)
492 # trunk
493 branch_prefix="trunk/KDE"
494 ;;
495 *)
496 # branch
497 branch_prefix="branches/KDE/$(get_kde_version)"
498 # @ECLASS-VARIABLE: ESVN_PROJECT_SUFFIX
499 # @DESCRIPTION
500 # Suffix appended to ESVN_PROJECT depending on fetched branch.
501 # Defaults is empty (for -9999 = trunk), and "-${PV}" otherwise.
502 ESVN_PROJECT_SUFFIX="-${PV}"
503 ;;
504 esac
505 # @ECLASS-VARIABLE: ESVN_MIRROR
506 # @DESCRIPTION:
507 # This variable allows easy overriding of default kde mirror service
508 # (anonsvn) with anything else you might want to use.
509 ESVN_MIRROR=${ESVN_MIRROR:=svn://anonsvn.kde.org/home/kde}
510 # Split ebuild, or extragear stuff
511 if [[ -n ${KMNAME} ]]; then
512 ESVN_PROJECT="${KMNAME}${ESVN_PROJECT_SUFFIX}"
513 if [[ -z ${KMNOMODULE} ]] && [[ -z ${KMMODULE} ]]; then
514 KMMODULE="${PN}"
515 fi
516 # Split kde-base/ ebuilds: (they reside in trunk/KDE)
517 case ${KMNAME} in
518 kdebase-*)
519 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/kdebase/${KMNAME#kdebase-}"
520 ;;
521 kdelibs-*)
522 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/kdelibs/${KMNAME#kdelibs-}"
523 ;;
524 kdereview*)
525 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
526 ;;
527 kdesupport)
528 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
529 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}"
530 ;;
531 kde*)
532 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/${KMNAME}"
533 ;;
534 extragear*|playground*)
535 # Unpack them in toplevel dir, so that they won't conflict with kde4-meta
536 # build packages from same svn location.
537 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
538 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}"
539 ;;
540 koffice)
541 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}"
542 ;;
543 *)
544 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
545 ;;
546 esac
547 else
548 # kdelibs, kdepimlibs
549 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/${PN}"
550 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}"
551 fi
552 # @ECLASS-VARIABLE: ESVN_UP_FREQ
553 # @DESCRIPTION:
554 # This variable is used for specifying the timeout between svn synces
555 # for kde-base and koffice modules. Does not affect misc apps.
556 # Default value is 1 hour.
557 [[ ${KDEBASE} = kde-base || ${KDEBASE} = koffice ]] && ESVN_UP_FREQ=${ESVN_UP_FREQ:-1}
558 ;;
559 git)
560 local _kmname
561 # @ECLASS-VARIABLE: EGIT_MIRROR
562 # @DESCRIPTION:
563 # This variable allows easy overriding of default kde mirror service
564 # (anongit) with anything else you might want to use.
565 EGIT_MIRROR=${EGIT_MIRROR:=git://anongit.kde.org}
566
567 # @ECLASS-VARIABLE: EGIT_REPONAME
568 # @DESCRIPTION:
569 # This variable allows overriding of default repository
570 # name. Specify only if this differ from PN and KMNAME.
571 if [[ -n ${EGIT_REPONAME} ]]; then
572 # the repository and kmname different
573 _kmname=${EGIT_REPONAME}
574 elif [[ -n ${KMNAME} ]]; then
575 _kmname=${KMNAME}
576 else
577 _kmname=${PN}
578 fi
579
580 # default branching
581 [[ ${PV} != 9999* && ${KDEBASE} == kde-base ]] && \
582 EGIT_BRANCH="KDE/$(get_kde_version)"
583
584 # default repo uri
585 EGIT_REPO_URI="${EGIT_MIRROR}/${_kmname}"
586
587 debug-print "${FUNCNAME}: Repository: ${EGIT_REPO_URI}"
588 debug-print "${FUNCNAME}: Branch: ${EGIT_BRANCH}"
589 ;;
590 esac
591}
592
593case ${BUILD_TYPE} in
594 live) _calculate_live_repo ;;
595 *) _calculate_src_uri ;;
596esac
597
598debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: SRC_URI is ${SRC_URI}"
599
600# @ECLASS-VARIABLE: PREFIX
601# @DESCRIPTION:
602# Set the installation PREFIX for non kde-base applications. It defaults to /usr.
603# kde-base packages go into KDE4 installation directory (/usr).
604# No matter the PREFIX, package will be built against KDE installed in /usr.
605
606# @FUNCTION: kde4-base_pkg_setup
607# @DESCRIPTION:
608# Do some basic settings
609kde4-base_pkg_setup() {
610 debug-print-function ${FUNCNAME} "$@"
611
612 if has handbook ${IUSE} || has "+handbook" ${IUSE} && [ "${KDE_HANDBOOK}" != optional ] ; then
613 eqawarn "Handbook support is enabled via KDE_HANDBOOK=optional in the ebuild."
614 eqawarn "Please do not just set IUSE=handbook, as this leads to dependency errors."
615 fi
616
617 if use_if_iuse kdeprefix; then
618 eerror "Sorry, kdeprefix support has been removed."
619 eerror "Please remove kdeprefix from your USE variable."
620 die "kdeprefix support has been removed"
621 fi
622
623 if [[ ${CATEGORY}/${PN} != kde-base/kdelibs && ${CATEGORY}/${PN} != kde-base/kde-env ]] && \
624 { [[ ${KDE_REQUIRED} == always ]] || { [[ ${KDE_REQUIRED} == optional ]] && use kde; }; } && \
625 has_version kde-base/kdelibs[kdeprefix]; then
626 eerror "Sorry, kdeprefix support has been removed."
627 eerror "Please rebuild kdelibs without kdeprefix support."
628 die "kdeprefix support has been removed"
629 fi
630
631 # Don't set KDEHOME during compilation, it will cause access violations
632 unset KDEHOME
633
634 # Check if gcc compiler is fresh enough.
635 # In theory should be in pkg_pretend but we check it only for kdelibs there
636 # and for others we do just quick scan in pkg_setup because pkg_pretend
637 # executions consume quite some time.
638 # We can only do this for EAPI 4 or later because the MERGE_TYPE variable
639 # is otherwise undefined.
640 if [[ ${EAPI:-0} != 3 ]]; then
641 if [[ ${MERGE_TYPE} != binary ]]; then
642 [[ $(gcc-major-version) -lt 4 ]] || \
643 ( [[ $(gcc-major-version) -eq 4 && $(gcc-minor-version) -le 3 ]] ) \
644 && die "Sorry, but gcc-4.3 and earlier wont work for KDE (see bug 354837)."
645 fi
646 fi
647
648 KDEDIR=/usr
649 : ${PREFIX:=/usr}
650 EKDEDIR=${EPREFIX}/usr
651
652 # Point to correct QT plugins path
653 QT_PLUGIN_PATH="${EPREFIX}/usr/$(get_libdir)/kde4/plugins/"
654
655 # Fix XDG collision with sandbox
656 export XDG_CONFIG_HOME="${T}"
657}
658
659# @FUNCTION: kde4-base_src_unpack
660# @DESCRIPTION:
661# This function unpacks the source tarballs for KDE4 applications.
662kde4-base_src_unpack() {
663 debug-print-function ${FUNCNAME} "$@"
664
665 if [[ ${BUILD_TYPE} = live ]]; then
666 case ${KDE_SCM} in
667 svn)
668 migrate_store_dir
669 subversion_src_unpack
670 ;;
671 git)
672 git-2_src_unpack
673 ;;
211 esac 674 esac
212 fi
213 unset _kmname _kmname_pv
214fi
215
216debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: SRC_URI is ${SRC_URI}"
217debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: DEPEND ${DEPEND} - before blockers"
218
219# Monolithic ebuilds should add blockers for split ebuilds in the same slot.
220# If KMNAME is not set then this is not a split package
221if [[ -n ${KDEBASE} && -z ${KMNAME} ]]; then
222 for _x in $(get-child-packages ${CATEGORY}/${PN}); do
223 DEPEND="${DEPEND} !${_x}:${SLOT}"
224 RDEPEND="${RDEPEND} !${_x}:${SLOT}"
225 done
226 unset _x
227fi
228
229debug-print "${BASH_SOURCE} ${LINENO} ${ECLASS} ${FUNCNAME}: DEPEND ${DEPEND} - after blockers"
230
231# @ECLASS-VARIABLE: PREFIX
232# @DESCRIPTION:
233# Set the installation PREFIX. All kde-base ebuilds go into the KDE4 installation directory.
234# Applications installed by the other ebuilds go into /usr/ by default, this value
235# can be superseded by defining PREFIX before inheriting kde4-base.
236if [[ -n ${KDEBASE} ]]; then
237 PREFIX=${KDEDIR}
238else
239 # if PREFIX is not defined we set it to the default value of /usr
240 PREFIX="${PREFIX:-/usr}"
241fi
242
243debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: SLOT ${SLOT} - KDEDIR ${KDEDIR} - KDEDIRS ${KDEDIRS}- PREFIX ${PREFIX} - NEED_KDE ${NEED_KDE}"
244
245# @FUNCTION: kde4-base_pkg_setup
246# @DESCRIPTION:
247# Adds flags needed by all of KDE 4 to $QT4_BUILT_WITH_USE_CHECK. Uses
248# kde4-functions_check_use from kde4-functions.eclass to print appropriate
249# errors and die if any required flags listed in $QT4_BUILT_WITH_USE_CHECK or
250# $KDE4_BUILT_WITH_USE_CHECK are missing.
251kde4-base_pkg_setup() {
252 debug-print-function $FUNCNAME "$@"
253
254 # KDE4 applications require qt4 compiled with USE="accessibility dbus gif jpeg png qt3support ssl zlib".
255 if has_version '<x11-libs/qt-4.4_alpha:4'; then
256 QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK} accessibility dbus gif jpeg png qt3support ssl zlib"
257 else 675 else
258 KDE4_BUILT_WITH_USE_CHECK="${KDE4_BUILT_WITH_USE_CHECK} 676 unpack ${A}
259 x11-libs/qt-core qt3support ssl 677 fi
260 x11-libs/qt-gui accessibility dbus 678}
261 x11-libs/qt-qt3support accessibility" 679
680# @FUNCTION: kde4-base_src_prepare
681# @DESCRIPTION:
682# General pre-configure and pre-compile function for KDE4 applications.
683# It also handles translations if KDE_LINGUAS is defined. See KDE_LINGUAS and
684# enable_selected_linguas() and enable_selected_doc_linguas()
685# in kde4-functions.eclass(5) for further details.
686kde4-base_src_prepare() {
687 debug-print-function ${FUNCNAME} "$@"
688
689 # enable handbook and linguas only when not using live ebuild
690
691 # Only enable selected languages, used for KDE extragear apps.
692 if [[ -n ${KDE_LINGUAS} ]]; then
693 enable_selected_linguas
694 fi
695
696 # Enable/disable handbooks for kde4-base packages
697 # kde-l10n inherits kde4-base but is metpackage, so no check for doc
698 # kdelibs inherits kde4-base but handle installing the handbook itself
699 if ! has kde4-meta ${INHERITED} && in_iuse handbook; then
700 if [[ ${KDEBASE} == kde-base ]]; then
701 if [[ ${PN} != kde-l10n && ${PN} != kdepim-l10n && ${PN} != kdelibs ]] && use !handbook; then
702 # documentation in kde4-functions
703 : ${KDE_DOC_DIRS:=doc}
704 local dir
705 for dir in ${KDE_DOC_DIRS}; do
706 sed -e "\!^[[:space:]]*add_subdirectory[[:space:]]*([[:space:]]*${dir}[[:space:]]*)!s/^/#DONOTCOMPILE /" \
707 -e "\!^[[:space:]]*ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*${dir}[[:space:]]*)!s/^/#DONOTCOMPILE /" \
708 -e "\!^[[:space:]]*macro_optional_add_subdirectory[[:space:]]*([[:space:]]*${dir}[[:space:]]*)!s/^/#DONOTCOMPILE /" \
709 -e "\!^[[:space:]]*MACRO_OPTIONAL_ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*${dir}[[:space:]]*)!s/^/#DONOTCOMPILE /" \
710 -i CMakeLists.txt || die "failed to comment out handbook"
711 done
262 fi 712 fi
263
264 if has debug ${IUSE//+} && use debug; then
265 if has_version '<x11-libs/qt-4.4.0_alpha:4'; then
266 QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK} debug"
267 else 713 else
268 KDE4_BUILT_WITH_USE_CHECK="${KDE4_BUILT_WITH_USE_CHECK} 714 enable_selected_doc_linguas
269 x11-libs/qt-core:4 debug
270 x11-libs/qt-gui:4 debug
271 x11-libs/qt-qt3support:4 debug
272 x11-libs/qt-svg:4 debug
273 x11-libs/qt-test:4 debug"
274 if has opengl ${IUSE//+} && use opengl || [[ ${OPENGL_REQUIRED} == always ]]; then
275 KDE4_BUILT_WITH_USE_CHECK="${KDE4_BUILT_WITH_USE_CHECK}
276 x11-libs/qt-opengl:4 debug"
277 fi 715 fi
278 fi 716 fi
279 fi
280 717
281 if has opengl ${IUSE//+} && use opengl || [[ ${OPENGL_REQUIRED} == always ]]; then 718 # SCM bootstrap
282 if has_version '<x11-libs/qt-4.4.0_alpha:4'; then 719 if [[ ${BUILD_TYPE} = live ]]; then
283 QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK} opengl" 720 case ${KDE_SCM} in
721 svn) subversion_src_prepare ;;
722 esac
284 fi 723 fi
285 fi
286 724
287 kde4-functions_check_use 725 # Apply patches
288} 726 base_src_prepare
289 727
290# @FUNCTION: kde4-base_apply_patches 728 # Save library dependencies
291# @DESCRIPTION: 729 if [[ -n ${KMSAVELIBS} ]] ; then
292# This function applies patches. 730 save_library_dependencies
293#
294# If the directory ${WORKDIR}/patches/ exists, we apply all patches in that
295# directory, provided they follow this format:
296# @CODE
297# - Monolithic ebuilds, (from kde-base)
298# - $CATEGORY=kde-base:
299# Apply ${CHILD_EBUILD_NAME}-${SLOT}-*{diff,patch}
300# - $CATEGORY=!kde-base:
301# Apply ${CHILD_EBUILD_NAME}-${PV}-*{diff,patch}
302# - Split ebuilds:
303# - $CATEGORY=kde-base:
304# Apply ${PN}-${SLOT}-*{diff,patch}
305# - $CATEGORY!=kde-base:
306# Apply ${PN}-${PV}-*{diff,patch}
307# @CODE
308#
309# If ${PATCHES} is non-zero all patches in it gets applied.
310kde4-base_apply_patches() {
311 local _patchdir _packages _p
312 _patchdir="${WORKDIR}/patches/"
313 if [[ -d "${_patchdir}" ]]; then
314 if is-parent-package ${CATEGORY}/${PN} ; then
315 _packages="$(get-child-packages ${CATEGORY}/${PN})"
316 _packages="${_packages//${CATEGORY}\//} ${PN}"
317 else
318 _packages="${PN}"
319 fi 731 fi
320 for _p in ${_packages}; do 732
321 PATCHES="${PATCHES} $(ls ${_patchdir}/${_p}-${PV}-*{diff,patch} 2>/dev/null)" 733 # Inject library dependencies
734 if [[ -n ${KMLOADLIBS} ]] ; then
735 load_library_dependencies
736 fi
737
738 # Hack for manuals relying on outdated DTD, only outside kde-base/koffice/...
322 if [[ -n "${KDEBASE}" ]]; then 739 if [[ -z ${KDEBASE} ]]; then
323 PATCHES="${PATCHES} $(ls ${_patchdir}/${_p}-${SLOT}-*{diff,patch} 2>/dev/null)" 740 find "${S}" -name "*.docbook" \
741 -exec sed -i -r \
742 -e 's:-//KDE//DTD DocBook XML V4\.1(\..)?-Based Variant V1\.[01]//EN:-//KDE//DTD DocBook XML V4.2-Based Variant V1.1//EN:g' {} + \
743 || die 'failed to fix DocBook variant version'
324 fi 744 fi
325 done
326 fi
327 [[ -n ${PATCHES} ]] && base_src_unpack autopatch
328} 745}
329 746
330# @FUNCTION: kde4-base_src_unpack 747# @FUNCTION: kde4-base_src_configure
331# @DESCRIPTION: 748# @DESCRIPTION:
332# This function unpacks the source tarballs for KDE4 applications. 749# Function for configuring the build of KDE4 applications.
333# 750kde4-base_src_configure() {
334# If no argument is passed to this function, then standard src_unpack is
335# executed. Otherwise options are passed to base_src_unpack.
336#
337# In addition it calls kde4-base_apply_patches when no arguments are passed to
338# this function.
339kde4-base_src_unpack() {
340 debug-print-function $FUNCNAME "$@" 751 debug-print-function ${FUNCNAME} "$@"
341 752
342 [[ -z "${KDE_S}" ]] && KDE_S="${S}" 753 # Build tests in src_test only, where we override this value
754 local cmakeargs=(-DKDE4_BUILD_TESTS=OFF)
343 755
344 if [[ -z $* ]]; then 756 if use_if_iuse debug; then
345 # Unpack first and deal with KDE patches after examing possible patch sets. 757 # Set "real" debug mode
346 # To be picked up, patches need to conform to the guidelines stated before. 758 CMAKE_BUILD_TYPE="Debugfull"
347 # Monolithic ebuilds will use the split ebuild patches.
348 [[ -d "${KDE_S}" ]] || unpack ${A}
349 kde4-base_apply_patches
350 else 759 else
351 # Call base_src_unpack, which unpacks and patches 760 # Handle common release builds
352 # step by step transparently as defined in the ebuild. 761 append-cppflags -DQT_NO_DEBUG
353 base_src_unpack $* 762 fi
763
764 # Set distribution name
765 [[ ${PN} = kdelibs ]] && cmakeargs+=(-DKDE_DISTRIBUTION_TEXT=Gentoo)
766
767 # Here we set the install prefix
768 tc-is-cross-compiler || cmakeargs+=(-DCMAKE_INSTALL_PREFIX="${EPREFIX}${PREFIX}")
769
770 # Use colors
771 QTEST_COLORED=1
772
773 # Shadow existing installations
774 unset KDEDIRS
775
776 #qmake -query QT_INSTALL_LIBS unavailable when cross-compiling
777 tc-is-cross-compiler && cmakeargs+=(-DQT_LIBRARY_DIR=${ROOT}/usr/$(get_libdir)/qt4)
778 #kde-config -path data unavailable when cross-compiling
779 tc-is-cross-compiler && cmakeargs+=(-DKDE4_DATA_DIR=${ROOT}/usr/share/apps/)
780
781 # sysconf needs to be /etc, not /usr/etc
782 cmakeargs+=(-DSYSCONF_INSTALL_DIR="${EPREFIX}"/etc)
783
784 if [[ $(declare -p mycmakeargs 2>&-) != "declare -a mycmakeargs="* ]]; then
785 if [[ ${mycmakeargs} ]]; then
786 eqawarn "mycmakeargs should always be declared as an array, not a string"
354 fi 787 fi
355 788 mycmakeargs=(${mycmakeargs})
356 # Updated cmake dir
357 if [[ -d "${WORKDIR}/cmake" ]] && [[ -d "${KDE_S}/cmake" ]]; then
358 ebegin "Updating cmake/ directory..."
359 rm -rf "${KDE_S}/cmake" || die "Unable to remove old cmake/ directory"
360 ln -s "${WORKDIR}/cmake" "${KDE_S}/cmake" || die "Unable to symlink the new cmake/ directory"
361 eend 0
362 fi 789 fi
790
791 mycmakeargs=("${cmakeargs[@]}" "${mycmakeargs[@]}")
792
793 cmake-utils_src_configure
363} 794}
364 795
365# @FUNCTION: kde4-base_src_compile 796# @FUNCTION: kde4-base_src_compile
366# @DESCRIPTION: 797# @DESCRIPTION:
367# General function for compiling KDE4 applications. 798# General function for compiling KDE4 applications.
368kde4-base_src_compile() { 799kde4-base_src_compile() {
369 debug-print-function ${FUNCNAME} "$@" 800 debug-print-function ${FUNCNAME} "$@"
370 801
371 kde4-base_src_configure
372 kde4-base_src_make
373}
374
375# @FUNCTION: kde4-base_src_configure
376# @DESCRIPTION:
377# Function for configuring the build of KDE4 applications.
378kde4-base_src_configure() {
379 debug-print-function ${FUNCNAME} "$@"
380
381 # Final flag handling
382 if has kdeenablefinal ${IUSE//+} && use kdeenablefinal; then
383 echo "Activating enable-final flag"
384 mycmakeargs="${mycmakeargs} -DKDE4_ENABLE_FINAL=ON"
385 fi
386
387 # Enable generation of HTML handbook
388 if has htmlhandbook ${IUSE//+} && use htmlhandbook; then
389 echo "Enabling building of HTML handbook"
390 mycmakeargs="${mycmakeargs} -DKDE4_ENABLE_HTMLHANDBOOK=ON"
391 fi
392
393 # Build tests in src_test only, where we override this value
394 mycmakeargs="${mycmakeargs} -DKDE4_BUILD_TESTS=OFF"
395
396 # Set distribution name
397 [[ ${PN} == "kdelibs" ]] && mycmakeargs="${mycmakeargs} -DKDE_DISTRIBUTION_TEXT=Gentoo"
398
399 # runpath linking
400 mycmakeargs="${mycmakeargs} -DKDE4_USE_ALWAYS_FULL_RPATH=ON"
401
402 # Here we set the install prefix
403 mycmakeargs="${mycmakeargs} -DCMAKE_INSTALL_PREFIX=${PREFIX}"
404
405 # Set environment
406 QTEST_COLORED=1
407 QT_PLUGIN_PATH=${KDEDIR}/$(get_libdir)/kde4/plugins/
408
409 cmake-utils_src_configureout
410}
411
412# @FUNCTION: kde4-base_src_make
413# @DESCRIPTION:
414# Function for building KDE4 applications.
415# Options are passed to cmake-utils_src_make.
416kde4-base_src_make() {
417 debug-print-function ${FUNCNAME} "$@"
418
419 cmake-utils_src_make "$@" 802 cmake-utils_src_compile "$@"
420} 803}
421 804
422# @FUNCTION: kde4-base_src_test 805# @FUNCTION: kde4-base_src_test
423# @DESCRIPTION: 806# @DESCRIPTION:
424# Function for testing KDE4 applications. 807# Function for testing KDE4 applications.
425kde4-base_src_test() { 808kde4-base_src_test() {
426 debug-print-function ${FUNCNAME} "$@" 809 debug-print-function ${FUNCNAME} "$@"
427 810
811 local kded4_pid
812
813 _test_runner() {
814 if [[ -n "${VIRTUALDBUS_TEST}" ]]; then
815 export $(dbus-launch)
816 kded4 2>&1 > /dev/null &
817 kded4_pid=$!
818 fi
819
820 cmake-utils_src_test
821 }
822
823 # When run as normal user during ebuild development with the ebuild command, the
824 # kde tests tend to access the session DBUS. This however is not possible in a real
825 # emerge or on the tinderbox.
826 # > make sure it does not happen, so bad tests can be recognized and disabled
827 unset DBUS_SESSION_BUS_ADDRESS DBUS_SESSION_BUS_PID
828
428 # Override this value, set in kde4-base_src_configure() 829 # Override this value, set in kde4-base_src_configure()
429 mycmakeargs="${mycmakeargs} -DKDE4_BUILD_TESTS=ON" 830 mycmakeargs+=(-DKDE4_BUILD_TESTS=ON)
430 cmake-utils_src_compile 831 cmake-utils_src_configure
832 kde4-base_src_compile
431 833
432 cmake-utils_src_test 834 if [[ ${VIRTUALX_REQUIRED} == always || ${VIRTUALX_REQUIRED} == test ]]; then
835 # check for sanity if anyone already redefined VIRTUALX_COMMAND from the default
836 if [[ ${VIRTUALX_COMMAND} != emake ]]; then
837 # surprise- we are already INSIDE virtualmake!!!
838 debug-print "QA Notice: This version of kde4-base.eclass includes the virtualx functionality."
839 debug-print " You may NOT set VIRTUALX_COMMAND or call virtualmake from the ebuild."
840 debug-print " Setting VIRTUALX_REQUIRED is completely sufficient. See the"
841 debug-print " kde4-base.eclass docs for details... Applying workaround."
842 _test_runner
843 else
844 VIRTUALX_COMMAND="_test_runner" virtualmake
845 fi
846 else
847 _test_runner
848 fi
849
850 if [ -n "${kded4_pid}" ] ; then
851 kill ${kded4_pid}
852 fi
853
854 if [ -n "${DBUS_SESSION_BUS_PID}" ] ; then
855 kill ${DBUS_SESSION_BUS_PID}
856 fi
433} 857}
434 858
435# @FUNCTION: kde4-base_src_install 859# @FUNCTION: kde4-base_src_install
436# @DESCRIPTION: 860# @DESCRIPTION:
437# Function for installing KDE4 applications. 861# Function for installing KDE4 applications.
438kde4-base_src_install() { 862kde4-base_src_install() {
439 debug-print-function ${FUNCNAME} "$@" 863 debug-print-function ${FUNCNAME} "$@"
440 864
441 kde4-base_src_make_doc 865 if [[ -n ${KMSAVELIBS} ]] ; then
866 install_library_dependencies
867 fi
868
869 # Install common documentation of KDE4 applications
870 local doc
871 if ! has kde4-meta ${INHERITED}; then
872 for doc in "${S}"/{AUTHORS,CHANGELOG,ChangeLog*,README*,NEWS,TODO,HACKING}; do
873 [[ -f ${doc} && -s ${doc} ]] && dodoc "${doc}"
874 done
875 for doc in "${S}"/*/{AUTHORS,CHANGELOG,ChangeLog*,README*,NEWS,TODO,HACKING}; do
876 [[ -f ${doc} && -s ${doc} ]] && newdoc "${doc}" "$(basename $(dirname ${doc})).$(basename ${doc})"
877 done
878 fi
879
442 cmake-utils_src_install 880 cmake-utils_src_install
443}
444 881
445# @FUNCTION: kde4-base_src_make_doc 882 # In EAPI 4+, we don't want ${PREFIX}/share/doc/HTML to be compressed,
446# @DESCRIPTION: 883 # because then khelpcenter can't find the docs
447# Function for installing the documentation of KDE4 applications. 884 [[ ${EAPI:-0} != 3 && -d ${ED}/${PREFIX}/share/doc/HTML ]] &&
448kde4-base_src_make_doc() { 885 docompress -x ${PREFIX}/share/doc/HTML
449 debug-print-function ${FUNCNAME} "$@" 886}
450 887
451 local doc 888# @FUNCTION: kde4-base_pkg_preinst
452 for doc in AUTHORS ChangeLog* README* NEWS TODO; do 889# @DESCRIPTION:
453 [[ -s $doc ]] && dodoc ${doc} 890# Function storing icon caches
454 done 891kde4-base_pkg_preinst() {
892 debug-print-function ${FUNCNAME} "$@"
455 893
456 if [[ -z ${KMNAME} ]]; then 894 gnome2_icon_savelist
457 for doc in {apps,runtime,workspace,.}/*/{AUTHORS,README*}; do 895 if [[ ${BUILD_TYPE} == live && ${KDE_SCM} == svn ]]; then
458 if [[ -s $doc ]]; then 896 subversion_pkg_preinst
459 local doc_complete=${doc}
460 doc="${doc#*/}"
461 newdoc "$doc_complete" "${doc%/*}.${doc##*/}"
462 fi
463 done
464 fi
465
466 if [[ -n ${KDEBASE} && -d "${D}"/usr/share/doc/${PF} ]]; then
467 # work around bug #97196
468 dodir /usr/share/doc/kde && \
469 mv "${D}"/usr/share/doc/${PF} "${D}"/usr/share/doc/kde/ || \
470 die "Failed to move docs to kde/ failed."
471 fi 897 fi
472} 898}
473 899
474# @FUNCTION: kde4-base_pkg_postinst 900# @FUNCTION: kde4-base_pkg_postinst
475# @DESCRIPTION: 901# @DESCRIPTION:
476# Function to rebuild the KDE System Configuration Cache after an application has been installed. 902# Function to rebuild the KDE System Configuration Cache after an application has been installed.
477kde4-base_pkg_postinst() { 903kde4-base_pkg_postinst() {
904 debug-print-function ${FUNCNAME} "$@"
905
906 gnome2_icon_cache_update
907 fdo-mime_desktop_database_update
908 fdo-mime_mime_database_update
478 buildsycoca 909 buildsycoca
910
911 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
912 if [[ ${BUILD_TYPE} = live ]]; then
913 echo
914 einfo "WARNING! This is an experimental live ebuild of ${CATEGORY}/${PN}"
915 einfo "Use it at your own risk."
916 einfo "Do _NOT_ file bugs at bugs.gentoo.org because of this ebuild!"
917 echo
918 fi
919 # for all 3rd party soft tell user that he SHOULD install kdebase-startkde or kdebase-runtime-meta
920 if [[ ${KDEBASE} != kde-base ]] && \
921 ! has_version 'kde-base/kdebase-runtime-meta' && \
922 ! has_version 'kde-base/kdebase-startkde'; then
923 if [[ ${KDE_REQUIRED} == always ]] || ( [[ ${KDE_REQUIRED} == optional ]] && use kde ); then
924 echo
925 ewarn "WARNING! Your system configuration contains neither \"kde-base/kdebase-runtime-meta\""
926 ewarn "nor \"kde-base/kdebase-startkde\". You need one of above."
927 ewarn "With this setting you are unsupported by KDE team."
928 ewarn "All missing features you report for misc packages will be probably ignored or closed as INVALID."
929 fi
930 fi
931 fi
479} 932}
480 933
481# @FUNCTION: kde4-base_pkg_postrm 934# @FUNCTION: kde4-base_pkg_postrm
482# @DESCRIPTION: 935# @DESCRIPTION:
483# Function to rebuild the KDE System Configuration Cache after an application has been removed. 936# Function to rebuild the KDE System Configuration Cache after an application has been removed.
484kde4-base_pkg_postrm() { 937kde4-base_pkg_postrm() {
938 debug-print-function ${FUNCNAME} "$@"
939
940 gnome2_icon_cache_update
941 fdo-mime_desktop_database_update
942 fdo-mime_mime_database_update
485 buildsycoca 943 buildsycoca
486} 944}

Legend:
Removed from v.1.6  
changed lines
  Added in v.1.119

  ViewVC Help
Powered by ViewVC 1.1.20